/**  
* <p>Title: TestController.java</p>  
* <p>Description: </p>  
* @author dsc  
* @date 2020年5月6日  
* @version 1.0  
*/
package com.yl8timer.kqj.yl8timer.ctrl;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yl8timer.kqj.yl8timer.entity.fk.FkDev;
import com.yl8timer.kqj.yl8timer.entity.fk.FkHsRequest;
import com.yl8timer.kqj.yl8timer.entity.fk.FkHsResponse;
import com.yl8timer.kqj.yl8timer.entity.fk.FkTask;
import com.yl8timer.kqj.yl8timer.entity.fk.FkTaskRelation;
import com.yl8timer.kqj.yl8timer.tools.Constant;
import com.yl8timer.kqj.yl8timer.tools.HSTools;
import com.yl8timer.kqj.yl8timer.tools.LogUtil;
import com.yl8timer.kqj.yl8timer.tools.MyUtil;
import com.yl8timer.kqj.yl8timer.tools.Result;
import com.yl8timer.kqj.yl8timer.tools.ResultUtil;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import cn.hutool.json.JSONObject;

/**
 * <p>
 * Title: TestController.java
 * </p>
 * <p>
 * Description:
 * </p>
 * 
 * @author dsc
 * @date 2020年5月6日
 * @version 1.0
 */
@RestController
@RequestMapping(value = "/", produces = { "application/json" })
public class FkController {

	@Autowired
	private HSTools hsTools;

	// 绑定考勤机
	@PostMapping("/addDev")
	public Result<FkDev> addDev(@RequestParam Integer orgCode, @RequestParam String devId) {
		FkDev fkDev0 = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev0 != null) {
			return ResultUtil.success();
		}
		FkDev fkDev = new FkDev();
		fkDev.setOrgCode(orgCode);
		fkDev.setDevId(devId);
		fkDev.setCreatedTime(new Date());
		fkDev.setUpdateTime(new Date());
		fkDev.insert();
		return ResultUtil.data(fkDev, "绑定成功");
	}

	// 向考勤机同步写入用户的注册数据和名称
	@PostMapping("/addUser")
	public Result<Object> addUser(@RequestParam String devId, @RequestParam String jsonStr) {
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId)); // 判断设备厂家
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺 2-浩顺3代
			boolean result = false;
			try {
				result = hsTools.setUser(devId, jsonStr); // 设置用户信息
			} catch (Exception e) {
				return ResultUtil.error("添加失败,请确认考勤机绑定状态");
			}
			if (result == false)
				return ResultUtil.error("添加失败");
			return ResultUtil.data("添加成功");
		} else
			// TODO 预留其他考勤机设备
			return ResultUtil.error("添加失败，请联系管理员");
	}

	// 添加、修改用户姓名
	@PostMapping("/addUserName")
	public Result<Object> addUserName(@RequestParam String devId, @RequestParam String userId,
			@RequestParam String userName) {
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺 2-浩顺3代
			boolean result = false;
			try {
				result = hsTools.setUserName(devId, userId, userName);
			} catch (Exception e) {
				return ResultUtil.error("添加失败,请确认考勤机绑定状态");
			}
			if (result == false)
				return ResultUtil.data("添加失败");
			return ResultUtil.data("添加成功");
		} else
			return ResultUtil.data("添加失败，请联系管理员");
	}

	// 添加、修改用户权限
	@PostMapping("/addUserPrivilege")
	public Result<Object> addUserPrivilege(@RequestParam String devId, @RequestParam String userId,
			@RequestParam(required = false) Integer privilege) {
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺 2-浩顺3代
			boolean result = false;
			try {
				result = hsTools.addUserPrivilege(devId, userId, privilege);
			} catch (Exception e) {
				return ResultUtil.error("添加失败,请确认考勤机绑定状态");
			}
			if (result == false)
				return ResultUtil.data("添加失败");
			return ResultUtil.data("添加成功");
		} else
			return ResultUtil.data("添加失败，请联系管理员");
	}

	// 同步考勤机时间
	@PostMapping("/setTime")
	public Result<String> setTime(@RequestParam String devId) {
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺 2-浩顺3代
			boolean result = false;
			try {
				result = hsTools.setTime(devId);
			} catch (Exception e) {
				return ResultUtil.error("添加失败,请确认考勤机绑定状态");
			}
			if (result == false)
				return ResultUtil.data("添加失败");
			return ResultUtil.data("同步成功");
		} else
			return ResultUtil.data("设置失败，请联系管理员");
	}

	// 删除考勤机用户
	@PostMapping("/deleteUser")
	public Result<String> deleteUser(@RequestParam String devId, @RequestParam String userId) {
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺 2-浩顺3代
			boolean result = false;
			try {
				result = hsTools.setDeleteUser(devId, userId);
			} catch (Exception e) {
				return ResultUtil.error("删除失败,请确认考勤机绑定状态");
			}
			if (result == false)
				return ResultUtil.data("删除失败");
			return ResultUtil.data("删除成功");
		} else
			return ResultUtil.data("删除失败，请联系管理员");
	}

	// 获取考勤机live信息
	@PostMapping("/getDevInfo")
	public Result<Integer> getDevInfo(@RequestParam String devId) {
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev == null)
			return ResultUtil.data(0, "考勤机不存在");

		long bet = DateUtil.between(fkDev.getUpdateTime(), new Date(), DateUnit.MINUTE);
		if (bet >= 5) // 超过5分钟没有响应则判断为不在线
			return ResultUtil.data(2, "考勤机离线");
		return ResultUtil.data(1, "考勤机在线");
	}

	// 获取用户信息
	@PostMapping("/getUserInfo")
	public Result<String> getUserInfo(@RequestParam String devId, @RequestParam String userId) {
		// 判断机器类型
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺 2-浩顺3代
			String transId = hsTools.getUserInfo(devId, userId);
			if (transId == null)
				return ResultUtil.error("获取失败");
			return ResultUtil.data(transId, "获取成功");
		} else {
			return ResultUtil.data("获取失败，请联系管理员");
		}
	}

	// 获取用户信息s
	@PostMapping("/getUsersInfo")
	public Result<List<String>> getUsersInfo(@RequestParam String devId, @RequestParam List<String> userIds) {
		// 判断机器类型
		FkDev fkDev = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, devId));
		String transId = null;
		List<String> transIds = new ArrayList<String>();
		if (fkDev != null && (fkDev.getOrgCode() == 1 || fkDev.getOrgCode() == 2)) { // 1-浩顺
			for (String userId : userIds) {
				transId = hsTools.getUserInfo(devId, userId);
				transIds.add(transId);
			}
			return ResultUtil.data(transIds, "获取成功，请等待设备响应");
		} else {
			return ResultUtil.error("获取失败，请联系管理员");
		}
	}

	// 获取任务状态
	@GetMapping("/getTaskInfo")
	public Result<JSONObject> getTaskInfo(@RequestParam Integer taskId) {
		FkTask fkTask = FkTask.builder().id(taskId).build().selectById();
		JSONObject json = new JSONObject();
		if (fkTask == null) {
			return ResultUtil.error("任务不存在");
		}
		Date beginDate = fkTask.getCreatedTime();
		Date endDate = fkTask.getSuccessTime();
		if (endDate != null) {
			Long time = endDate.getTime() - beginDate.getTime();
			json.put("executionTime", time);
		}
		Integer result = fkTask.getStatus();

		json.put("id", taskId);
		if (result == 1) {
			json.put("result", "任务执行中");
			json.put("resultCode", 1);
			getUserList(json, taskId);
		} else if (result == 2) {
			json.put("result", "任务已完成");
			json.put("resultCode", 2);
			getUserList(json, taskId);
		} else if (result == 3) {
			json.put("result", "任务超时失败");
			json.put("resultCode", 3);
			getUserList(json, taskId);
		} else {
			json.put("result", "任务不存在或未开始");
			json.put("resultCode", 0);
		}

		return ResultUtil.data(json);

	}

	private void getUserList(JSONObject json, Integer taskId) {
		List<FkTaskRelation> fkTaskRelations = FkTaskRelation.builder().build()
				.selectList(new LambdaQueryWrapper<FkTaskRelation>().eq(FkTaskRelation::getTaskId, taskId));

		List<JSONObject> list = new LinkedList<JSONObject>();
		for (FkTaskRelation fkTaskRelation : fkTaskRelations) {
			JSONObject json3 = new JSONObject();
			json3.put("userId", fkTaskRelation.getUserId());
			String getTransId = fkTaskRelation.getGetTransId();
			if (getTransId != null) {
				FkHsRequest get = FkHsRequest.builder().id(Integer.parseInt(getTransId)).build().selectById();
				json3.put("getStatus", get.getStatus());
			} else {
				json3.put("getStatus", "null");
			}
			String setTransId = fkTaskRelation.getSetTransId();
			if (setTransId != null) {
				FkHsRequest set = FkHsRequest.builder().id(Integer.parseInt(setTransId)).build().selectById();
				json3.put("setStatus", set.getStatus());
			} else {
				json3.put("setStatus", "null");
			}

			list.add(json3);
		}
		json.put("userList", list);
	}

//	// 同步考勤机数据 TODO
//	@Transactional
//	@PostMapping("/setUserInfoOntime")
//	public Result<String> setUserInfoOntime(@RequestParam String oldDevId, @RequestParam String newDevId,
//			@RequestParam List<String> ids) {
//		// 判断机器类型
//		FkDev fkDev1 = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, oldDevId));
//		FkDev fkDev2 = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, newDevId));
//		if (fkDev1 == null || fkDev2 == null)
//			return ResultUtil.error("请先绑定考勤机");
//		Integer code1 = fkDev1.getOrgCode();
//		Integer code2 = fkDev2.getOrgCode();
//		boolean result = false;
//		if (code1 != code2)
//			return ResultUtil.error("不同品牌考勤机无法同步用户数据");
//		if ((code1 == 1 && code2 == 1) || (code1 == 2 && code2 == 2)) { // 1-浩顺 2-浩顺3代
//			try {
//				for (String id : ids) {
//					String transId = hsTools.getUserInfo(oldDevId, id);
//
//					byte[] str = FkHsResponse.builder().build()
//							.selectOne(new LambdaQueryWrapper<FkHsResponse>().eq(FkHsResponse::getTransId, transId))
//							.getTotalByte();
//
//					result = hsTools.setUserInfo(newDevId, str);
//				}
//			} catch (Exception e) {
//				return ResultUtil.error("请确认考勤机绑定状态");
//			}
//
//			if (result != true)
//				return ResultUtil.error("获取失败");
//			return ResultUtil.data("获取成功");
//		} else {
//			return ResultUtil.data("获取失败，请联系管理员");
//		}
//
//	}

	@PostMapping(value = "/") // 考勤机http请求地址
	public void getData() throws UnsupportedEncodingException {
		attendanceMachineRequestPath(); // 考勤机http请求内容
	}

	public void attendanceMachineRequestPath() throws UnsupportedEncodingException {

		String sRequestCode = "";
		String sTransId = "";
		byte[] bytEmpty = new byte[0];

		final String csFuncName = "Page_Load";

		hsTools.request.setCharacterEncoding("UTF-8");
		hsTools.response.setCharacterEncoding("UTF-8");
		hsTools.response.setHeader("content-type", "text/html;charset=UTF-8");
		// 是否打印
		hsTools.log = LogUtil.getInstance(true);
		try {

			sRequestCode = hsTools.request.getHeader("request_code");
			if (!MyUtil.isValidEngDigitString(sRequestCode)) {
				hsTools.log.e(csFuncName, "Invalid request_code : " + sRequestCode);
				return;
			}
			sTransId = hsTools.request.getHeader("trans_id");
			if (sTransId == null)
				sTransId = "";
			hsTools.log.i(csFuncName, "1 - request_code : " + sRequestCode + " ,trans_id : " + sTransId);

			String sDevId = hsTools.request.getHeader("dev_id");
			if (!MyUtil.isValidEngDigitString(sDevId)) {
				hsTools.log.e(csFuncName, "error - Invalid dev_id : " + sDevId);
				return;
			}

			int lenContent = hsTools.GetRequestStreamBytes(hsTools.request);
			if (lenContent < 0) {
				hsTools.log.e(csFuncName, "2.1" + lenContent);
				return;
			}

			// 块序号
			int nBlkNo = 0;
			if (hsTools.request.getHeader("blk_no") != null)
				nBlkNo = Integer.parseInt(hsTools.request.getHeader("blk_no"));

			int vRet;
			if (nBlkNo > 0) {
				vRet = hsTools.AddBlockData(sDevId, nBlkNo, hsTools.bytRequestBin);
				if (vRet != 0) {
					hsTools.log.e(csFuncName, "3.0 - error - AddBlockData:" + vRet);
					hsTools.SendResponseToClient("ERROR_ADD_BLOCK_DATA", sTransId, "", bytEmpty, hsTools.response);
					return;
				}
				hsTools.log.i(csFuncName, "3.1");

				hsTools.SendResponseToClient("OK", sTransId, "", bytEmpty, hsTools.response);
				return;
			} else if (nBlkNo < 0) {
				hsTools.SendResponseToClient("ERROR_INVLAID_BLOCK_NO", sTransId, "", bytEmpty, hsTools.response);
				return;
			} else {
				hsTools.GetBlockDataAndRemove(sDevId);
				hsTools.bytRequestTotal = hsTools.ConcateByteArray(hsTools.bytRequestTotal, hsTools.bytRequestBin);
			}

			FkHsResponse fkHsResponse = new FkHsResponse();
			fkHsResponse.setCommand(sRequestCode);
			fkHsResponse.setDevId(sDevId);
			fkHsResponse.setTime(new Date());
			String byteStr = new String();
//			System.err.println("byteStr:" + byteStr);
//			System.err.println("byteStr:"+byteStr);
//			System.err.println("nBlkNo:"+nBlkNo);
			fkHsResponse.setTotalByte(hsTools.bytRequestTotal);
//			if (sRequestCode != Constant.REQ_CODE_RECV_CMD) {
			fkHsResponse.setTransId(sTransId);
			fkHsResponse.insert();
//			}
			switch (sRequestCode) {
			case Constant.REQ_CODE_RECV_CMD:
				hsTools.RemoveOldBlockStream();
				hsTools.OnReceiveCmd(sDevId, sTransId, hsTools.bytRequestTotal, hsTools.response);
				break;
			case Constant.REQ_CODE_SEND_CMD_RESULT:
				hsTools.OnSendCmdResult(sDevId, sTransId, hsTools.bytRequestTotal, hsTools.response, hsTools.request);
				break;
			case Constant.REQ_CODE_REALTIME_GLOG: // 实时指纹打卡
				hsTools.OnRealtimeGLog(sDevId, hsTools.bytRequestTotal, hsTools.response, hsTools.request);
				break;
			case Constant.REQ_CODE_REALTIME_ENROLL: // 新添加指纹
				hsTools.OnRealtimeEnrollData(sDevId, hsTools.bytRequestTotal, hsTools.response, hsTools.request);
				break;
			case "":
				break;
			default:
				hsTools.SendResponseToClient("OK", sTransId, "", bytEmpty, hsTools.response);
				break;
			}
		} catch (Exception e) {
			hsTools.log.e("Page_Load---->" + e.getMessage());
			e.printStackTrace();
		} finally {
		}

	}

}
