/**  
* <p>Title: TaskController.java</p>  
* <p>Description: </p>  
* @author dsc  
* @date 2020年5月14日  
* @version 1.0  
*/
package com.yl8timer.kqj.yl8timer.ctrl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yl8timer.kqj.yl8timer.entity.fk.FkDev;
import com.yl8timer.kqj.yl8timer.entity.fk.FkTaskRelation;
import com.yl8timer.kqj.yl8timer.entity.fk.FkTask;
import com.yl8timer.kqj.yl8timer.tools.HSTools;
import com.yl8timer.kqj.yl8timer.tools.Result;
import com.yl8timer.kqj.yl8timer.tools.ResultUtil;

/**
 * <p>
 * Title: TaskController.java
 * </p>
 * <p>
 * Description:
 * </p>
 * 
 * @author dsc
 * @date 2020年5月14日
 * @version 1.0
 */

@RestController
@RequestMapping(value = "/task", produces = { "application/json" })
public class TaskController {

	@Autowired
	private HSTools hsTools;

	@PostMapping("/addTask")
	@Transactional
	public Result<Integer> addDev(@RequestParam List<String> userIds, @RequestParam String oldDevId,
			@RequestParam String newDevId) {

		// 判断机器类型
		FkDev fkDev1 = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, oldDevId));
		FkDev fkDev2 = FkDev.builder().build().selectOne(new LambdaQueryWrapper<FkDev>().eq(FkDev::getDevId, newDevId));
		if (fkDev1 == null || fkDev2 == null)
			return ResultUtil.error("请先绑定考勤机");
		Integer code1 = fkDev1.getOrgCode();
		Integer code2 = fkDev2.getOrgCode();
		if (code1 != code2)
			return ResultUtil.error("不同品牌考勤机无法同步用户数据");
		if ((code1 == 1 && code2 == 1) || (code1 == 2 && code2 == 2)) { // 1-浩顺 2-浩顺3代

			FkTask fkTask = new FkTask();
			fkTask.setCreatedTime(new Date());
			fkTask.setOldDevId(oldDevId);
			fkTask.setNewDevId(newDevId);

			fkTask.setStatus(0);
			fkTask.insert();
			Integer taskId = fkTask.getId(); // 任务id
			for (String userId : userIds) {
				FkTaskRelation fkTaskRelation = new FkTaskRelation();
				fkTaskRelation.setTaskId(taskId);
				fkTaskRelation.setUserId(userId);
				String transId = null;
				try {
					transId = hsTools.getUserInfo(oldDevId, userId);
				} catch (Exception e) {
					return ResultUtil.error("请确保考勤机设备已连接服务器");
				}
				fkTaskRelation.setGetTransId(transId);
				fkTaskRelation.insert();

			}
			fkTask.setStatus(1);
			fkTask.insertOrUpdate();

			return ResultUtil.data(fkTask.getId(), "任务添加成功,等待设备响应完成");

		} else {
			return ResultUtil.error("请联系管理员");
		}
	}
}
